function [NBD_Response] = NBD_Response_fnc(f, Response)

% NBD Average Narrow Band Deviation (dB) in each
% 1/2-octave band from 100 Hz - 12 kHz
% The average amplitude value within the 1/2-octave band n, yb is the amplitude
% value of band b, and N is the total number of 1/2  octave bands between 100 Hz-12 kHz. 
% The mean absolute deviation within each 1/2-octave band is based a sample of 10 equally log-spaced data points.

% Calcuate the Narrow band Deviation from Each of the 14 bands average SPL 
% for 14 bands from 100 to 12kHz 
% Each band with 10 points
% input should be 20 points per octave like NFS data

% -------------------------------------------------------------------------
% Band center: 14 bands from 100 to 12kHz each band with 10 points
% Each of the 14 bands average SPL
% -------------------------------------------------------------------------

% Cardinal 10pts per 1/2 octave
Band_Mid = [114
            161.2203461
            228
            322.4406922
            456
            644.8813844
            912
            1289.762769
            1824
            2579.525538
            3648
            5159.051076
            7296
            10318.10215];


% Cardinal 10pts per 1/2 octave
% Band_Mid = [118.9207
%             168.1793
%             237.8414
%             336.3586
%             475.6828
%             672.7171
%             951.3657
%             1345.434
%             1902.731
%             2690.869
%             3805.463
%             5381.737
%             7610.925
%             10763.47];  

% % Cardinal 10pts per 1/2 octave
% Band_Mid = [100.0000
%             141.4214
%             200.0000
%             282.8427
%             400.0000
%             565.6854
%             800.0000
%             1131.400
%             1600.000
%             2262.700
%             3200.000
%             4525.500
%             6400.000
%             9051.000
%             12800.00];   


% % Cardinal 10pts per 1/2 octave exact
% Band_Mid = [
%  105.925372517729
%  149.623565609443
%  211.348903983665
%  298.538261891796
%  421.696503428582
%  595.662143529011
%  841.395141645195
%  1188.50222743702
%  1678.80401812256
%  2371.37370566165
%  3349.65439157828
%  4731.51258961481
%  6683.43917568614
%  9440.60876285923
%  13335.2143216332];
% 

        
        
for k = 1:length(Band_Mid)
    Band_low_indx(k)   = find( f <= Band_Mid(k) / 2^(1/4), 1, 'last') + 1;
    Band_high_indx(k)  = find( f <= Band_Mid(k) * 2^(1/4), 1, 'last');
    Cardinal(k,1)      = Band_high_indx(k) - Band_low_indx(k) + 1;   
    Mean_Response(k,1) = mean( Response( Band_low_indx(k) : Band_high_indx(k) ) , 1 );
end

% band_start  = f(Band_low_indx)
% band_finish = f(Band_high_indx)

% -------------------------------------------------------------------------
% Within each of the 14 bands, 
% each of the 10 points deviation from the average SPL  
% -------------------------------------------------------------------------
for k = 1 : length(Band_Mid) 
    for l = 1 : Cardinal(k,1)
        Deviation_Response(l,k) = abs( Mean_Response(k,1) - Response( Band_low_indx(k)+l-1 ) );
%         RawSPL_band(l,k)        = Response( Band_low_indx(k)+l-1 );
    end
end
% RawSPL_band
% Mean_Response
% Deviation_Response 

% -------------------------------------------------------------------------
% For each 14 bands average deviation from the average SPL
% -------------------------------------------------------------------------
Mean_Deviation_Response = mean( Deviation_Response, 1 );

% -------------------------------------------------------------------------
% Average deviation from the 14 bands averages
% -------------------------------------------------------------------------
NBD_Response  = mean( Mean_Deviation_Response, 2 );
% NBD_Response  = sum( Mean_Deviation_Response, 2 ) / length(Band_Mid);
% NBD_Response  = sum( sum( Deviation_Response, 1 ) ,2 ) / sum(Cardinal);

% -------------------------------------------------------------------------
% Average deviation from the 14 bands averages
% -------------------------------------------------------------------------
% sumCardinal    = sum(Cardinal)
% NBD_Responseb  = sum( Mean_Deviation_Response, 2 ) / length(Band_Mid)
% NBD_Responsec  = sum( Mean_Deviation_Response, 2 )
% Sum_Deviation_Response = sum( Deviation_Response, 1 );
% NBD_Response  = sum( Sum_Deviation_Response, 2 ) / length(Band_Mid)

% Band_Mid = [
% 89.1250938133746
% 125.892541179417
% 177.827941003892
% 251.188643150958
% 354.813389233575
% 501.187233627272
% 707.945784384138
% 1000.00000000000
% 1412.53754462275
% 1995.26231496888
% 2818.38293126445
% 3981.07170553497
% 5623.41325190349
% 7943.28234724280
% 11220.1845430196];

% Band_Mid = [
% 89 
% 125
% 180
% 250
% 355
% 500
% 710
% 1000
% 1400
% 2000
% 2800
% 4000
% 5600
% 8000
% 11000];

% Band_Mid = [ 
% 125
% 180
% 250
% 355
% 500
% 710
% 1000
% 1400
% 2000
% 2800
% 4000
% 5600
% 8000
% 11000];

% Band_Mid = [ 
% % 88.388
% 125.00
% 176.78
% 250.00
% 353.56
% 500.00
% 707.10
% 1000.0
% 1414.2
% 2000.0
% 2828.4
% 4000.0
% 5656.9
% 8000.0
% 11313.7];

% % nominal 1/2 bands 
% Band_Mid = [
% 105
% 150
% 210
% 300
% 420
% 600
% 840
% 1200
% 1700
% 2350
% 3350
% 4750
% 6700
% 9450
% 13500];

% Band_Mid = [ 
% 15.625
% 22.097
% 31.250
% 44.194
% 62.500
% 88.388
% 125.00
% 176.78
% 250.00
% 353.56
% 500.00
% 707.10
% 1000.0
% 1414.2
% 2000.0
% 2828.4
% 4000.0
% 5656.9
% 8000.0
% 11313.7
% 16000.0];




